/*
 *  DelRec.java  -  Joris van Rantwijk
 *  in271 Databeheer
 *
 *  Test programma
 */

import java.util.Date;
import java.io.IOException;

public class DelRec 
{

	static String filename;
	static String bestandorg;
	static String rectype;
	static int key;

	static BestandsOrganisatie bestand;


	static void openFile() throws IOException
	{
		Class rt = null;

		System.out.println("Open bestand ...");

		try {
			rt = Class.forName(rectype);
		} catch (Exception e) { e.printStackTrace(); System.exit(1); }

		if (bestandorg.equals("SequentieelFile"))
			bestand = new SequentieelFile(filename, rt);
		else if (bestandorg.equals("StaticHash"))
			bestand = new StaticHash(filename, rt);
		else if (bestandorg.equals("IndexDirect"))
			bestand = new IndexDirect(filename, rt);
		else if (bestandorg.equals("ExtendibleHash"))
			bestand = new ExtendibleHash(filename, rt);
		else if (bestandorg.equals("BBoom"))
			bestand = new BBoom(filename, rt);
		else
			throw new RuntimeException("Onbekende bestandsorganisatie " + bestandorg);
	}


	static void closeFile() throws IOException
	{
		System.out.println("Sluit bestand ...");
		bestand.close();
	}


	public static void main(String[] args)
	{
		Record r;
		
		if (args.length != 4) {
			System.err.println("Gebruik: java DelRec <file> <bestandorg> <rectype> <key>");
			System.exit(1);
		}
						  
		filename = args[0];
		bestandorg = args[1];
		rectype = args[2];
		key = Integer.parseInt(args[3]);

		try {

			openFile();
			bestand.delete(key);
			closeFile();
			System.out.println(bestand.diskaccess + " disk accesses");

		} catch (Exception e) {
			e.printStackTrace();
		}

	}

}
