/*
 *  TestApp.java  -  Joris van Rantwijk
 *  in271 Databeheer
 */

import java.awt.*;
import java.awt.event.*;
import java.io.IOException;
import java.util.Date;
import java.text.DateFormat;
import java.text.ParseException;


class MessageDialog extends Dialog
{
	public MessageDialog(Frame parent, String title, String msg)
	{
		super(parent, title, true);

		Panel p1 = new Panel();
		p1.add(new Label(msg));
		add(p1, "Center");

		Panel p2 = new Panel();
		Button ok = new Button("Ok");
		p2.add(ok, "South");
		add(p2, "South");

		ok.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) { setVisible(false); }
		} );

		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent evt) { setVisible(false); }
		} );

		setSize(250, 200);
	}
}


class OpenBestandDialog extends Dialog
{
	TextField bnaam;
	Checkbox cStaticHash;
	Checkbox cIndexDirect;
	Checkbox cExtendibleHash;
	Checkbox cBBoom;
	Checkbox cMedewerker;
	Checkbox cAfdeling;
	boolean ok;
	Button okbutton;
	Button cancelbutton;

	public OpenBestandDialog(Frame parent)
	{
		super(parent, "Open Bestand", true);

		Panel p;
		Label l;

		setSize(400, 250);

		p = new Panel();
		l = new Label("Bestandnaam");
		p.add(l);
		bnaam = new TextField(25);
		p.add(bnaam);
		add(p, "North");

		p = new Panel();
		p.setLayout(new GridLayout(5, 1, 0, 0));
		l = new Label("Bestandsorganisatie");
		p.add(l);
		CheckboxGroup cg = new CheckboxGroup();
		cStaticHash = new Checkbox("Static Hashing", cg, true);
		p.add(cStaticHash);
		cIndexDirect = new Checkbox("Index Direct", cg, false);
		p.add(cIndexDirect);
		cExtendibleHash = new Checkbox("Extendible Hashing", cg, false);
		p.add(cExtendibleHash);
		cBBoom = new Checkbox("B+ Boom", cg, false);
		p.add(cBBoom);
		add(p, "West");

		p = new Panel();
		p.setLayout(new GridLayout(3, 1, 0, 0));
		l = new Label("RecordType");
		p.add(l);
		cg = new CheckboxGroup();
		cMedewerker = new Checkbox("Medewerker", cg, true);
		p.add(cMedewerker);
		cAfdeling = new Checkbox("Afdeling", cg, false);
		p.add(cAfdeling);
		add(p, "East");

		p = new Panel();
		okbutton = new Button("Ok");
		p.add(okbutton);
		cancelbutton = new Button("Cancel");
		p.add(cancelbutton);
		add(p, "South");

		okbutton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) { 
				ok = true;
				setVisible(false); 
			}
		} );
		
		cancelbutton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) { 
				ok = false;
				setVisible(false); 
			}
		} );
		
		addWindowListener(new WindowAdapter() { 
			public void windowClosing(WindowEvent e) { setVisible(false); }
		} );

	}

}


class MedewerkerDialog extends Dialog
{
	TextField key;
	TextField naam;
	TextField adres;
	TextField plaats;
	TextField geboortedatum;
	TextField functie;
	TextField afd;
	Button okbutton;
	Button cancelbutton;
	boolean ok;

	public MedewerkerDialog(Frame parent, String title, boolean editable)
	{
		super(parent, title, true);

		Panel p;
		Label l;

		setLayout(new GridLayout(0, 1));
		setSize(400, 300);

		p = new Panel();
		l = new Label("Key");
		p.add(l);
		key = new TextField(10);
		key.setEditable(editable);
		p.add(key);
		add(p);

		p = new Panel();
		l = new Label("Naam");
		p.add(l);
		naam = new TextField(25);
		naam.setEditable(editable);
		p.add(naam);
		add(p);

		p = new Panel();
		l = new Label("Adres");
		p.add(l);
		adres = new TextField(25);
		adres.setEditable(editable);
		p.add(adres);
		add(p);

		p = new Panel();
		l = new Label("Plaats");
		p.add(l);
		plaats = new TextField(25);
		plaats.setEditable(editable);
		p.add(plaats);
		add(p);

		p = new Panel();
		l = new Label("Geb.Datum");
		p.add(l);
		geboortedatum = new TextField(15);
		geboortedatum.setEditable(editable);
		p.add(geboortedatum);
		add(p);

		p = new Panel();
		l = new Label("Functie");
		p.add(l);
		functie = new TextField(15);
		functie.setEditable(editable);
		p.add(functie);
		l = new Label("Afd");
		p.add(l);
		afd = new TextField(8);
		afd.setEditable(editable);
		p.add(afd);
		add(p);

		p = new Panel();
		okbutton = new Button("Ok");
		p.add(okbutton);
		if (editable) {
			cancelbutton = new Button("Cancel");
			p.add(cancelbutton);
		}
		add(p);

		okbutton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) { 
				ok = true;
				setVisible(false); 
			}
		} );

		if (editable)
			cancelbutton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt) { 
					ok = false;
					setVisible(false); 
				}
			} );
		
		addWindowListener(new WindowAdapter() { 
			public void windowClosing(WindowEvent e) { setVisible(false); }
		} );
	}

}


class AfdelingDialog extends Dialog
{
	TextField key;
	TextField afdnaam;
	TextField telefoon;
	TextField locatie;
	TextField budget;
	Button okbutton;
	Button cancelbutton;
	boolean ok;

	public AfdelingDialog(Frame parent, String title, boolean editable)
	{
		super(parent, title, true);

		Panel p;
		Label l;

		setLayout(new GridLayout(0, 1));
		setSize(350, 250);

		p = new Panel();
		l = new Label("Key");
		p.add(l);
		key = new TextField(10);
		key.setEditable(editable);
		p.add(key);
		add(p);

		p = new Panel();
		l = new Label("AfdNaam");
		p.add(l);
		afdnaam = new TextField(25);
		afdnaam.setEditable(editable);
		p.add(afdnaam);
		add(p);

		p = new Panel();
		l = new Label("Telefoon");
		p.add(l);
		telefoon = new TextField(15);
		telefoon.setEditable(editable);
		p.add(telefoon);
		add(p);

		p = new Panel();
		l = new Label("Locatie");
		p.add(l);
		locatie = new TextField(15);
		locatie.setEditable(editable);
		p.add(locatie);
		add(p);

		p = new Panel();
		l = new Label("Budget");
		p.add(l);
		budget = new TextField(15);
		budget.setEditable(editable);
		p.add(budget);
		add(p);

		p = new Panel();
		okbutton = new Button("Ok");
		p.add(okbutton);
		if (editable) {
			cancelbutton = new Button("Cancel");
			p.add(cancelbutton);
		}
		add(p);

		okbutton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) { 
				ok = true;
				setVisible(false); 
			}
		} );

		if (editable)
			cancelbutton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt) { 
					ok = false;
					setVisible(false); 
				}
			} );
		
		addWindowListener(new WindowAdapter() { 
			public void windowClosing(WindowEvent e) { setVisible(false); }
		} );
	}

}


class KeyDialog extends Dialog
{
	TextField key;
	Button okbutton;
	Button cancelbutton;
	boolean ok;

	public KeyDialog(Frame parent, String title)
	{
		super(parent, title, true);

		setSize(300, 150);

		Panel p = new Panel();
		Label l = new Label("Key");
		p.add(l);
		key = new TextField(10);
		p.add(key);
		add(p, "Center");

		p = new Panel();
		okbutton = new Button("Ok");
		p.add(okbutton);
		cancelbutton = new Button("Cancel");
		p.add(cancelbutton);
		add(p, "South");

		okbutton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) { 
				ok = true;
				setVisible(false); 
			}
		} );

		cancelbutton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) { 
				ok = false;
				setVisible(false); 
			}
		} );
		
		addWindowListener(new WindowAdapter() { 
			public void windowClosing(WindowEvent e) { setVisible(false); }
		} );
	}

}


public class TestApp extends Frame
{

	static String bestandnaam;
	static Class recordtype;
	static Class bestandsorganisatie;
	static BestandsOrganisatie bestand;
	static TestApp app;

	public TestApp()
	{
		Panel p = new Panel();

		Button binsert = new Button("Insert");
		Button bretrieve = new Button("Retrieve");
		Button bupdate = new Button("Update");
		Button bdelete = new Button("Delete");
		Button bclose = new Button("Close");

		p.add(binsert);
		p.add(bretrieve);
		p.add(bupdate);
		p.add(bdelete);
		p.add(bclose);
		add(p, "Center");

		binsert.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) { doInsert(); }
		} );
		bretrieve.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) { doRetrieve(); }
		} );
		bupdate.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) { doUpdate(); }
		} );
		bdelete.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) { doDelete(); }
		} );
		bclose.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) { 
				doClose(); 
				System.exit(0);
			}
		} );

		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent evt) { 
				doClose();
				System.exit(0);
			}
		} );

		setSize(300, 150);
		setTitle("TestApp");
	}

	static boolean editMedewerker(Medewerker m, String title, boolean editable)
	{
		DateFormat df = DateFormat.getDateInstance(DateFormat.SHORT);
		MedewerkerDialog d = new MedewerkerDialog(app, title, editable);
		d.key.setText("" + m.key);
		d.naam.setText(m.naam);
		d.adres.setText(m.adres);
		d.plaats.setText(m.plaats);
		d.geboortedatum.setText(df.format(m.geboortedatum));
		d.functie.setText(m.functie);
		d.afd.setText("" + m.afd);
		d.show();
		d.dispose();
		if (!d.ok || !editable) return false;
		try {
			m.key = Integer.parseInt(d.key.getText());
			m.naam = d.naam.getText();
			m.adres = d.adres.getText();
			m.plaats = d.plaats.getText();
			m.geboortedatum = df.parse(d.geboortedatum.getText());
			m.functie = d.functie.getText();
			m.afd = Integer.parseInt(d.afd.getText());
		} catch (NumberFormatException e) {
			Dialog md = new MessageDialog(app, "Exception", e.toString());
			md.show();
			md.dispose();
			return false;
		} catch (ParseException e) {
			Dialog md = new MessageDialog(app, "Exception", e.toString());
			md.show();
			md.dispose();
			return false;
		}
		return true;
	}

	static boolean editAfdeling(Afdeling afd, String title, boolean editable)
	{
		AfdelingDialog d = new AfdelingDialog(app, title, editable);
		d.key.setText("" + afd.key);
		d.afdnaam.setText(afd.afdnaam);
		d.telefoon.setText(afd.telefoon);
		d.locatie.setText(afd.locatie);
		d.budget.setText("" + afd.budget);
		d.show();
		d.dispose();
		if (!d.ok || !editable) return false;
		try {
			afd.key = Integer.parseInt(d.key.getText());
			afd.afdnaam = d.afdnaam.getText();
			afd.telefoon = d.telefoon.getText();
			afd.locatie = d.locatie.getText();
			afd.budget = Integer.parseInt(d.budget.getText());
		} catch (NumberFormatException e) {
			Dialog md = new MessageDialog(app, "Exception", e.toString());
			md.show();
			md.dispose();
			return false;
		}
		return true;
	}

	static void doInsert() {
		Record r;
		if (recordtype == Medewerker.class) {
			r = new Medewerker(0, "", "", "", new Date(0), "", 0);
			if (!editMedewerker((Medewerker) r, "Insert Medewerker", true))
				return;
		} else {
			r = new Afdeling(0, "", "", "", 0);
			if (!editAfdeling((Afdeling) r, "Insert Afdeling", true))
				return;
		}
		try {
			bestand.diskaccess = 0;
			bestand.insert(r);
			Dialog d = new MessageDialog(app, "Ok", "Record toegevoegd: " +
				bestand.diskaccess + " diskaccessen");
			d.show();
			d.dispose();
		} catch (IOException e) {
			System.out.println(e);
			System.exit(0);
		} catch (Exception e  ) {
			Dialog d = new MessageDialog(app, "Exception", e.toString());
			d.show();
			d.dispose();
		}
	}

	static void doRetrieve() {
		Record r = null;
		int key;
		KeyDialog kd = new KeyDialog(app,
			(recordtype == Medewerker.class) ? 
			"Retrieve Medewerker" : "Retrieve Afdeling");
		kd.key.setText("0");
		kd.show();
		kd.dispose();
		if (!kd.ok) return;
		try {
			key = Integer.parseInt(kd.key.getText());
		} catch (NumberFormatException e) {
			Dialog d = new MessageDialog(app, "Exception", e.toString());
			d.show();
			d.dispose();
			return;
		}
		try {
			bestand.diskaccess = 0;
			r = bestand.retrieve(key);
		} catch (IOException e) {
			System.out.println(e);
			System.exit(0);
		} catch (Exception e) {
			Dialog d = new MessageDialog(app, "Exception", e.toString());
			d.show();
			d.dispose();
			return;
		}
		if (r == null) {
			Dialog d = new MessageDialog(app, "Niet gevonden", 
				"Het record met key " + key + " bestaat niet");
			d.show();
			d.dispose();
			return;
		}
		if (recordtype == Medewerker.class)
			editMedewerker((Medewerker) r, "Retrieved Medewerker", false);
		else
			editAfdeling((Afdeling) r, "Retrieved Afdeling", false);
	}

	static void doUpdate() {
		Record r = null;
		int key;
		KeyDialog kd = new KeyDialog(app,
			(recordtype == Medewerker.class) ? 
			"Update Medewerker" : "Update Afdeling");
		kd.key.setText("0");
		kd.show();
		kd.dispose();
		if (!kd.ok) return;
		try {
			key = Integer.parseInt(kd.key.getText());
		} catch (NumberFormatException e) {
			Dialog d = new MessageDialog(app, "Exception", e.toString());
			d.show();
			d.dispose();
			return;
		}
		try {
			bestand.diskaccess = 0;
			r = bestand.retrieve(key);
		} catch (IOException e) {
			System.out.println(e);
			System.exit(0);
		} catch (Exception e) {
			Dialog d = new MessageDialog(app, "Exception", e.toString());
			d.show();
			d.dispose();
			return;
		}
		if (r == null) {
			Dialog d = new MessageDialog(app, "Niet gevonden", 
				"Het record met key " + key + " bestaat niet");
			d.show();
			d.dispose();
			return;
		}
		if (recordtype == Medewerker.class) {
			if (!editMedewerker((Medewerker) r, "Update Medewerker", true))
				return;
		} else {
			if (!editAfdeling((Afdeling) r, "Update Afdeling", true))
				return;
		}
		try {
			bestand.diskaccess = 0;
			bestand.update(r);
			Dialog d = new MessageDialog(app, "Ok", "Record gewijzigd: " +
				bestand.diskaccess + " diskaccessen");
			d.show();
			d.dispose();
		} catch (IOException e) {
			System.out.println(e);
			System.exit(0);
		} catch (Exception e  ) {
			Dialog d = new MessageDialog(app, "Exception", e.toString());
			d.show();
			d.dispose();
		}
	}

	static void doDelete() {
		int key;
		KeyDialog kd = new KeyDialog(app,
			(recordtype == Medewerker.class) ? 
			"Retrieve Medewerker" : "Retrieve Afdeling");
		kd.key.setText("0");
		kd.show();
		kd.dispose();
		if (!kd.ok) return;
		try {
			key = Integer.parseInt(kd.key.getText());
		} catch (NumberFormatException e) {
			Dialog d = new MessageDialog(app, "Exception", e.toString());
			d.show();
			d.dispose();
			return;
		}
		try {
			bestand.diskaccess = 0;
			bestand.delete(key);
			Dialog d = new MessageDialog(app, "Ok", "Record verwijderd: " +
				bestand.diskaccess + " diskaccessen");
			d.show();
			d.dispose();
		} catch (IOException e) {
			System.out.println(e);
			System.exit(0);
		} catch (Exception e) {
			Dialog d = new MessageDialog(app, "Exception", e.toString());
			d.show();
			d.dispose();
			return;
		}
	}

	static void doClose()
	{
		if (bestand != null) {
			bestand.diskaccess = 0;
			try {
				bestand.close();
			} catch (IOException e) {
				System.out.println("" + e);
				System.exit(0);
			}
			Dialog d = new MessageDialog(app, "Ok", "Bestand gesloten: " +
				bestand.diskaccess + " diskaccessen");
			d.show();
			d.dispose();
		}
	}

	static void openBestand()
	{
		OpenBestandDialog d = new OpenBestandDialog(app);
		d.show();
		
		if (!d.ok) System.exit(0);

		bestandnaam = d.bnaam.getText();

		if (d.cMedewerker.getState())
			recordtype = Medewerker.class;
		else if (d.cAfdeling.getState())
			recordtype = Afdeling.class;

		try { 
			if (d.cStaticHash.getState()) {
				bestandsorganisatie = StaticHash.class;
				bestand = new StaticHash(bestandnaam, recordtype);
			} else if (d.cIndexDirect.getState()) {
				bestandsorganisatie = IndexDirect.class;
				bestand = new IndexDirect(bestandnaam, recordtype);
			} else if (d.cExtendibleHash.getState()) {
				bestandsorganisatie = ExtendibleHash.class;
				bestand = new ExtendibleHash(bestandnaam, recordtype);
			} else if (d.cBBoom.getState()) {
				bestandsorganisatie = BBoom.class;
				bestand = new BBoom(bestandnaam, recordtype);
			}
		} catch (IOException e) {
			System.out.println("" + e);
			System.exit(0);
		}

		d.dispose();

		Dialog d2 = new MessageDialog(app, "Ok", "Bestand geopend: " +
			bestand.diskaccess + " diskaccessen");
		d2.show();
		d2.dispose();

		app.setTitle("TestApp - " + bestandnaam);
	}

	public static void main(String[] args)
	{
		app = new TestApp();
		app.show();

		openBestand();
	}

}
